#include <iostream>
#include <ginac/ginac.h>

using namespace std;
using namespace GiNaC;

int main()
{	
/*
 * Define  constants and symbols
 */
	const double x_val = 0.1;
	const double y_val = 0.07;
	symbol x("x"), y("y");
	symbol epsilon("epsilon");
/*
 * Create the expression f and series expand it.
 */
	ex f = exp(-x*y+x-y*y);
	ex f_series = f.subs(lst(x==epsilon*x, y==epsilon*y));
	f_series = expand(series_to_poly(f_series.series(epsilon, 4)));
	f_series = f_series.subs(epsilon==1);
/*
 * Print f and its expansion.
 */
	cout << "The expression: " << f << endl;
	cout << "has the series expansion: " << f_series << endl;
/*
 * Print values.
 */
	ex f_val = f.subs(lst(x==x_val,y==y_val));
	ex series_val = f_series.subs(lst(x==x_val,y==y_val));
	cout << "for x = " << x_val << " and y = " << y_val << ", we have" << endl;
	cout << "expression: " << f_val << endl;
	cout << "series: " << series_val << endl;
	return 0;
}
