#include <ginac/ginac.h>
#include "deltafun.h"

using namespace GiNaC;

REGISTER_FUNCTION(integ, dummy());

REGISTER_FUNCTION(delta, dummy());

ex trydeltaintegrals(const ex &x)
{	if (is_a<mul>(x))
	{	for (int i=0; i<x.nops(); ++i)
		{	if (!is_ex_the_function(x.op(i), integ))
				continue;
			ex integ_var = x.op(i).op(0);
			for (int j=0; j<x.nops(); ++j)
			{	if (!is_ex_the_function(x.op(j), delta))
					continue;
				ex delta_arg = x.op(j).op(0);
				if (!delta_arg.is_polynomial(integ_var))
					continue;
				if (delta_arg.degree(integ_var) != 1)
					continue;
				ex a = delta_arg.coeff(integ_var, 1);
				ex b = delta_arg.coeff(integ_var, 0);
				ex result = x/x.op(i)/x.op(j);
				result = result.subs( integ_var == -b/a );
				result = result/abs(a);
				result = trydeltaintegrals(result);
				return result;
			}
		}
		return x;
	}
	if (is_a<add>(x))
		return x.map(trydeltaintegrals);
	return x;
}
